<template>
  <v-fade-transition>
    <div v-if="menu">
      <div class="w-full h-full">
        <v-dialog
          v-model="dialog"
          :scrim="scrimColor ?? ''"
          scroll-strategy="close"
          close-on-content-click
        >
          <template #activator="{ props, isActive }">
            <!-- SpeedDial activator -->
            <div
              v-bind="props"
              class="flex justify-center items-center self-end cursor-pointer fixed bottom-6 sm:!bottom-12 right-6 sm:!right-12 rounded-full transition-all duration-300 md:hidden"
              :class="isActive ? `w-8 h-8 bg-white border-solid border-2 border-primary !z-[2] ${iconCustomClass}` : 'w-[50px] h-[50px] bg-primary'">
              <Icon
                :icon="isActive ?'ic:baseline-plus' : icon"
                :height="isActive ? '16' : '21'"
                :width="isActive ? '16' : '21'"
                class="transition-all duration-300"
                :class="[isActive ? 'rotate-[135deg] text-primary' : 'rotate-0 text-white', iconCustomClass]"
              />
            </div>
          </template>

          <template #default>
            <div class="w-screen h-screen flex flex-col items-end justify-end pr-[65px] pb-[70px]">
              <slot name="default">
                <div class="flex flex-col gap-4 items-end">
                  <div class="flex items-center gap-2 cursor-pointer">
                    <svn-title h3 semi-bold color="white">Export to PDF</svn-title>

                    <svn-icon-button icon="material-symbols:upload" button-size="lg" circle />
                  </div>

                  <div class="flex items-center gap-2 cursor-pointer">
                    <svn-title h3 semi-bold color="white">Send emails to trainers</svn-title>

                    <svn-icon-button icon="mdi:email-arrow-right-outline" button-size="lg" circle />
                  </div>
                </div>
              </slot>
            </div>
          </template>
        </v-dialog>
      </div>
    </div>

    <div v-else>
      <div
        v-if="default"
        class="inline-flex gap-1 px-4 items-center justify-center w-fit h-14 cursor-pointer !fixed bottom-6 right-6 sm:!bottom-12 sm:!right-12
          !rounded-2xl !bg-primary shadow active:!bg-primary-active"
        @click="(toTop && alignTop) ? goToTop() : ''"
      >
        <div v-if="text">
          <svn-text sm medium color="white">
            {{ text }}
          </svn-text>
        </div>

        <div>
          <Icon
            :icon="icon"
            height="24"
            width="24"
            class="text-white"
          />
        </div>
      </div>

      <div
        v-else-if="square"
        class="flex gap-8 py-2 items-center justify-center cursor-pointer !fixed bottom-6 right-6 sm:!bottom-12 sm:!right-12 shadow"
        :class="[mini ? '!rounded-xl !w-10 !h-10 !bg-white' : '!rounded-2xl !w-14 !h-14 !bg-primary active:!bg-primary-active', doubleIcon ? 'bottom-[92px]' : 'bottom-6 sm:!bottom-12', toTop && alignTop ? 'block' : 'hidden']"
        @click="goToTop"
      >
        <slot v-if="loading" name="loading" />

        <div v-else>
          <Icon
            :icon="icon"
            height="24"
            width="24"
            :class="mini ? '!text-primary active:!text-primary-active' : 'text-white'"
          />
        </div>
      </div>

      <div
        v-else-if="round"
        class="flex gap-8 py-2 items-center justify-center w-14 h-14 cursor-pointer !fixed bottom-6 right-6 sm:!bottom-12 sm:!right-12
          !rounded-full shadow"
        :class="[mini ? '!w-10 !h-10 !bg-white' : '!w-14 !h-14 !bg-primary active:!bg-primary-active', doubleIcon ? 'bottom-[92px]' : 'bottom-6 sm:!bottom-12', toTop && alignTop ? 'block' : 'hidden']"
        @click="toTop && alignTop ? goToTop() : ''"
      >
        <div>
          <Icon
            :icon="icon"
            height="24"
            width="24"
            :class="mini ? '!text-primary active:!text-primary-active' : 'text-white'"
          />
        </div>
      </div>
    </div>
  </v-fade-transition>
</template>

<script setup>
import { ref, onMounted, onUnmounted } from "vue";
import SvnIconButton from "./button/SvnIconButton.vue";
import SvnTitle from "./styles/SvnTitle.vue";
import SvnText from "./styles/SvnText.vue";
import { Icon } from "@iconify/vue";

const props = defineProps({
  default: { type: Boolean, default: false },
  square: { type: Boolean, default: false },
  round: { type: Boolean, default: false },
  mini: { type: Boolean, default: false },
  menu: { type: Boolean, default: false },
  icon: { type: String, default: 'ic:round-vertical-align-top' },
  text: { type: String, default: 'Action' },
  iconCustomClass: { type: String, default: '!z-[9999]' },
  scrimColor: { type: String, default: ''},
  loading: { type: Boolean, default: false },
  doubleIcon: { type: Boolean, default: false },
  pageRatioDisplay: {type: Number, default: 4},
  toTop: { type: Boolean, default: false },
})

const dialog = ref(false)
const alignTop = ref(false)

onMounted(async () => {
  window.addEventListener("scroll", alignFunc);
});


onUnmounted(() => {
  window.removeEventListener("scroll", alignFunc)
});

const goToTop = () => {
  window.scrollTo({top: 0, left: 0, behavior: "smooth"})
}

const alignFunc = () => {
  alignTop.value = (document.body.scrollTop > window.innerHeight / props.pageRatioDisplay ||
  document.documentElement.scrollTop > window.innerHeight / props.pageRatioDisplay)
}

defineExpose({
  dialog
})

</script>

<style scoped>
</style>
